/** @license React vundefined
 * scheduler.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

'use strict';
Object.defineProperty(exports, '__esModule', { value: !0 });
var d = void 0,
  f = void 0,
  g = void 0;
exports.unstable_now = void 0;
exports.unstable_forceFrameRate = void 0;
var k = Date,
  l = 'function' === typeof setTimeout ? setTimeout : void 0,
  n = 'function' === typeof clearTimeout ? clearTimeout : void 0,
  p =
    'function' === typeof requestAnimationFrame
      ? requestAnimationFrame
      : void 0,
  q =
    'function' === typeof cancelAnimationFrame ? cancelAnimationFrame : void 0,
  r = void 0,
  t = void 0;
function u(a) {
  r = p(function(b) {
    n(t);
    a(b);
  });
  t = l(function() {
    q(r);
    a(exports.unstable_now());
  }, 100);
}
if ('object' === typeof performance && 'function' === typeof performance.now) {
  var v = performance;
  exports.unstable_now = function() {
    return v.now();
  };
} else
  exports.unstable_now = function() {
    return k.now();
  };
if ('undefined' === typeof window || 'function' !== typeof MessageChannel) {
  var w = null,
    x = function(a) {
      if (null !== w)
        try {
          w(a);
        } finally {
          w = null;
        }
    };
  d = function(a) {
    null !== w ? setTimeout(d, 0, a) : ((w = a), setTimeout(x, 0, !1));
  };
  f = function() {
    w = null;
  };
  g = function() {
    return !1;
  };
  exports.unstable_forceFrameRate = function() {};
} else {
  'undefined' !== typeof console &&
    ('function' !== typeof p &&
      console.error(
        "This browser doesn't support requestAnimationFrame. Make sure that you load a polyfill in older browsers. https://fb.me/react-polyfills"
      ),
    'function' !== typeof q &&
      console.error(
        "This browser doesn't support cancelAnimationFrame. Make sure that you load a polyfill in older browsers. https://fb.me/react-polyfills"
      ));
  var y = null,
    z = !1,
    A = -1,
    B = !1,
    C = !1,
    D = 0,
    E = 33,
    F = 33,
    G = !1;
  g = function() {
    return D <= exports.unstable_now();
  };
  exports.unstable_forceFrameRate = function(a) {
    0 > a || 125 < a
      ? console.error(
          'forceFrameRate takes a positive int between 0 and 125, forcing framerates higher than 125 fps is not unsupported'
        )
      : 0 < a
      ? ((F = Math.floor(1e3 / a)), (G = !0))
      : ((F = 33), (G = !1));
  };
  var H = new MessageChannel(),
    I = H.port2;
  H.port1.onmessage = function() {
    z = !1;
    var a = y,
      b = A;
    y = null;
    A = -1;
    var c = exports.unstable_now(),
      e = !1;
    if (0 >= D - c)
      if (-1 !== b && b <= c) e = !0;
      else {
        B || ((B = !0), u(J));
        y = a;
        A = b;
        return;
      }
    if (null !== a) {
      C = !0;
      try {
        a(e);
      } finally {
        C = !1;
      }
    }
  };
  var J = function(a) {
    if (null !== y) {
      u(J);
      var b = a - D + F;
      b < F && E < F && !G ? (8 > b && (b = 8), (F = b < E ? E : b)) : (E = b);
      D = a + F;
      z || ((z = !0), I.postMessage(void 0));
    } else B = !1;
  };
  d = function(a, b) {
    y = a;
    A = b;
    C || 0 > b ? I.postMessage(void 0) : B || ((B = !0), u(J));
  };
  f = function() {
    y = null;
    z = !1;
    A = -1;
  };
}
var K = null,
  L = !1,
  M = 3,
  N = -1,
  O = -1,
  P = !1,
  Q = !1;
function R() {
  if (!P && null !== K) {
    var a = K.expirationTime;
    Q ? f() : (Q = !0);
    d(S, a);
  }
}
function T() {
  var a = K,
    b = K.next;
  if (K === b) K = null;
  else {
    var c = K.previous;
    K = c.next = b;
    b.previous = c;
  }
  a.next = a.previous = null;
  c = a.callback;
  b = a.expirationTime;
  a = a.priorityLevel;
  var e = M,
    m = O;
  M = a;
  O = b;
  try {
    var h = c(L || 1 === a);
  } catch (U) {
    throw U;
  } finally {
    (M = e), (O = m);
  }
  if ('function' === typeof h)
    if (
      ((h = {
        callback: h,
        priorityLevel: a,
        expirationTime: b,
        next: null,
        previous: null,
      }),
      null === K)
    )
      K = h.next = h.previous = h;
    else {
      c = null;
      a = K;
      do {
        if (a.expirationTime >= b) {
          c = a;
          break;
        }
        a = a.next;
      } while (a !== K);
      null === c ? (c = K) : c === K && ((K = h), R());
      b = c.previous;
      b.next = c.previous = h;
      h.next = c;
      h.previous = b;
    }
}
function S(a) {
  Q = !1;
  P = !0;
  var b = L;
  L = a;
  try {
    if (a)
      for (; null !== K; ) {
        var c = exports.unstable_now();
        if (K.expirationTime <= c) {
          do T();
          while (null !== K && K.expirationTime <= c);
        } else break;
      }
    else if (null !== K) {
      do T();
      while (null !== K && !g());
    }
  } finally {
    (P = !1), (L = b), R();
  }
}
exports.unstable_ImmediatePriority = 1;
exports.unstable_UserBlockingPriority = 2;
exports.unstable_NormalPriority = 3;
exports.unstable_IdlePriority = 5;
exports.unstable_LowPriority = 4;
exports.unstable_runWithPriority = function(a, b) {
  switch (a) {
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
      break;
    default:
      a = 3;
  }
  var c = M,
    e = N;
  M = a;
  N = exports.unstable_now();
  try {
    return b();
  } catch (m) {
    throw (R(), m);
  } finally {
    (M = c), (N = e);
  }
};
exports.unstable_next = function(a) {
  switch (M) {
    case 1:
    case 2:
    case 3:
      var b = 3;
      break;
    default:
      b = M;
  }
  var c = M,
    e = N;
  M = b;
  N = exports.unstable_now();
  try {
    return a();
  } catch (m) {
    throw (R(), m);
  } finally {
    (M = c), (N = e);
  }
};
exports.unstable_scheduleCallback = function(a, b, c) {
  var e = -1 !== N ? N : exports.unstable_now();
  if ('object' === typeof c && null !== c && 'number' === typeof c.timeout)
    c = e + c.timeout;
  else
    switch (a) {
      case 1:
        c = e + -1;
        break;
      case 2:
        c = e + 250;
        break;
      case 5:
        c = e + 1073741823;
        break;
      case 4:
        c = e + 1e4;
        break;
      default:
        c = e + 5e3;
    }
  a = {
    callback: b,
    priorityLevel: a,
    expirationTime: c,
    next: null,
    previous: null,
  };
  if (null === K) (K = a.next = a.previous = a), R();
  else {
    b = null;
    e = K;
    do {
      if (e.expirationTime > c) {
        b = e;
        break;
      }
      e = e.next;
    } while (e !== K);
    null === b ? (b = K) : b === K && ((K = a), R());
    c = b.previous;
    c.next = b.previous = a;
    a.next = b;
    a.previous = c;
  }
  return a;
};
exports.unstable_cancelCallback = function(a) {
  var b = a.next;
  if (null !== b) {
    if (b === a) K = null;
    else {
      a === K && (K = b);
      var c = a.previous;
      c.next = b;
      b.previous = c;
    }
    a.next = a.previous = null;
  }
};
exports.unstable_wrapCallback = function(a) {
  var b = M;
  return function() {
    var c = M,
      e = N;
    M = b;
    N = exports.unstable_now();
    try {
      return a.apply(this, arguments);
    } catch (m) {
      throw (R(), m);
    } finally {
      (M = c), (N = e);
    }
  };
};
exports.unstable_getCurrentPriorityLevel = function() {
  return M;
};
exports.unstable_shouldYield = function() {
  return !L && ((null !== K && K.expirationTime < O) || g());
};
exports.unstable_continueExecution = function() {
  null !== K && R();
};
exports.unstable_pauseExecution = function() {};
exports.unstable_getFirstCallbackNode = function() {
  return K;
};
